#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <bitset>
#include <ctime>
#include <vector>
#include <cstring>

#define maxn 100000
#define maxm 20
#define maxtest 1000

using namespace std;

int n,m, optimum;
long long dp[maxn+1][maxm+1];
long long comb[maxm+1][maxm+1];
int popcount[1<<maxm];
bool precalc;

void pascal()
{
    comb[1][0] = comb[1][1] = 1;

    for (int i = 2; i <= maxm; ++i)
    {
        comb[i][0] = 1;

        for (int j = 1; j <= i; ++j)
        {
            comb[i][j] = comb[i-1][j] + comb[i-1][j-1];
        }
    }
}

void dinamica()
{
    for (int j = 0; j <= m; ++j)
        dp[0][j] = 1;

    for (int i = 1; i <= maxn; ++i)
    {
        dp[i][0] = 1;

        for (int j = 1; j <= m; ++j)
        {
            for (int k = 0; k <= j; ++k)
            {
                dp[i][j] += comb[j][k] * dp[i-1][k];
            }
        }
    }

    optimum = 0;
    while (dp[optimum][m] < n)
        ++optimum;
}

void pop()
{
    for (int i = 0; i < (1<<maxm); ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if ((i>>j)&1)
                popcount[i]++;
        }
    }
}

void solve()
{
    getBottlesAndKrillins(n,m);

    if (!precalc)
    {
        pascal();
        dinamica();
        pop();
        precalc = 1;
    }

    vector<int> rats;
    for (int i = 1; i <= m; ++i)
        rats.push_back(i);
    vector<int> bottles;
    for (int i = 1; i <= n; ++i)
        bottles.push_back(i);

    for (int round = 1; ; ++round)
    {
        if (bottles.size() == 1)
        {
            revealBottle(bottles[0]);
            break;
        }

        int conf = 0, i = 0;
        while (conf < (1<<rats.size()) && i < bottles.size())
        {
            int c = 0;
            for (; c < dp[optimum - round][rats.size()-popcount[conf]] && i+c < bottles.size(); ++c)
            {
                for (int j = 0; j < m; ++j)
                {
                    if((conf>>j)&1)
                        giveBottleToKrillin(bottles[i+c], rats[j]);
                }
            }
            i = i+c;
            ++conf;
        }

        testKrillins();
        int t;
        int d[maxm+10];
        getDeadKrillins(t,d);

        vector<int>newRats, newBottles;
        int myconf = 0;

        for (int i = 0; i < t; ++i)
        {
            for (int j = 0; j < rats.size(); ++j)
            {
                if (rats[j] == d[i])
                {
                    myconf |= (1<<j);
                    break;
                }
            }
        }
        for (int i = 0; i < rats.size(); ++i)
        {
            if (!((myconf>>i)&1))
                newRats.push_back(rats[i]);
        }

        conf = 0; i = 0;
        while(1)
        {
            if (conf == myconf)
            {
                int c = 0;
                for (; c < dp[optimum - round][rats.size()-popcount[conf]] && i+c < bottles.size(); ++c)
                {
                    newBottles.push_back(bottles[i+c]);
                }
                break;
            }
            else
            {
                i = i + dp[optimum - round][rats.size()-popcount[conf]];
            }
            ++conf;
        }

        rats = newRats;
        bottles = newBottles;
    }
}
